



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Readiness 探测 - 每天5分钟玩转 Docker 容器技术（144）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Readiness 探测 - 每天5分钟玩转 Docker 容器技术（144）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 11:26:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>除了 Liveness 探测，Kubernetes Health Check 机制还包括 Readiness 探测。</p>
<p>用户通过 Liveness 探测可以告诉 Kubernetes 什么时候通过重启容器实现自愈；Readiness 探测则是告诉 Kubernetes 什么时候可以将容器加入到 Service 负载均衡池中，对外提供服务。</p>
<p>Readiness 探测的配置语法与 Liveness 探测完全一样，下面是个例子：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/775365/201803/775365-20180320052731153-2049165013.png"></p>
<p>这个配置文件只是将前面例子中的&nbsp;<code>liveness</code>&nbsp;替换为了&nbsp;<code>readiness</code>，我们看看有什么不同的效果。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/775365/201803/775365-20180320052742996-1486081007.png"></p>
<p>Pod&nbsp;<code>readiness</code>&nbsp;的&nbsp;<code>READY</code>&nbsp;状态经历了如下变化：</p>
<ol><li><p>刚被创建时，<code>READY</code>&nbsp;状态为不可用。</p></li>
<li><p>15 秒后（initialDelaySeconds + periodSeconds），第一次进行 Readiness 探测并成功返回，设置&nbsp;<code>READY</code>&nbsp;为可用。</p></li>
<li><p>30 秒后，<code>/tmp/healthy</code>&nbsp;被删除，连续 3 次 Readiness 探测均失败后，<code>READY</code>&nbsp;被设置为不可用。</p></li></ol>
<p>通过&nbsp;<code>kubectl describe pod readiness</code>&nbsp;也可以看到 Readiness 探测失败的日志。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/775365/201803/775365-20180320052756036-1882709376.png"></p>
<p>下面对 Liveness 探测和 Readiness 探测做个比较：</p>
<ol><li><p>Liveness 探测和 Readiness 探测是两种 Health Check 机制，如果不特意配置，Kubernetes 将对两种探测采取相同的默认行为，即通过判断容器启动进程的返回值是否为零来判断探测是否成功。</p></li>
<li><p>两种探测的配置方法完全一样，支持的配置参数也一样。不同之处在于探测失败后的行为：Liveness 探测是重启容器；Readiness 探测则是将容器设置为不可用，不接收 Service 转发的请求。</p></li>
<li><p>Liveness 探测和 Readiness 探测是独立执行的，二者之间没有依赖，所以可以单独使用，也可以同时使用。用 Liveness 探测判断容器是否需要重启以实现自愈；用 Readiness 探测判断容器是否已经准备好对外提供服务。</p></li></ol>
<p>理解了 Liveness 探测和 Readiness 探测的原理，下一节我们会讨论如何在业务场景中使用 Health Check。</p>
<p><strong>书籍：<br></strong>1.《每天5分钟玩转Docker容器技术》<br><a href="https://item.jd.com/16936307278.html" rel="external nofollow noreferrer">https://item.jd.com/16936307278.html</a></p>
<p>2.《每天5分钟玩转OpenStack》<br><a href="https://item.jd.com/12086376.html" rel="external nofollow noreferrer">https://item.jd.com/12086376.html</a></p>
<p><img referrerpolicy="no-referrer"src="https://i.imgsafe.org/68/68da21ce15.png"></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zr6xqy.html">BPM协同平台解决方案分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlm5ke9.html">&lbrack;转&rsqb;ASP&period;NET Core 开发-Logging 使用NLog 写日志文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mjkp08.html">XmlSerializer的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw5p4lq.html">Android 控件属性介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gxdrlq.html">Activiti之 Exclusive Gateway</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j5zvw8.html">第二个冲刺 Sprint</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zvpj09.html">实现在Android开发中的Splash Screen开场屏的效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z57d29.html">Objective-C编码规范：26个方面解决iOS开发问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xnwmw9.html">phpstorm一个窗口打开多个项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvpem1q.html">Gprinter Android SDK V2&period;1 使用说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/96orr5v9.html">Code First研究学习1&lowbar;Reverse  Enginner Code  First</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zgnln9.html">iOS SDK：预览和打开文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojj0w5q.html">杭州电  1052 Tian Ji -- The Horse Racing（贪婪）</a>
		</li>
						<li><a href="https://www.batexi.com/a/950d1508.html">vue指令v-pre示例解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zo1v59.html">HTML5 input date属性引起的探索&mdash;&mdash;My97DatePicker（日期选择插件）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjprz28.html">配置Zookeeper、Dubbox</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zom65nq.html">系统磁盘优化&mdash;&mdash;&amp;quot&semi;&sol;var&sol;spool&sol;postfix&sol;maildrop&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rmryn9.html">Python实现多线程调用GDAL执行正射校正</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdl4309.html">faster rcnn讲解很细</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj2nx39.html">redis数据库通过dump&period;rdb文件恢复数据库或者数据库迁移</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4z2m739.html">剑指offer第三天</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj25j19.html">nyoj 1022 合纵连横 经典并查集</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkr5o08.html">天猫精灵X1智能音箱使用感想</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjerwy8.html">设置TCP&lowbar;USER&lowbar;TIMEOUT参数来判断tcp连接是否断开</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo246dq.html">win10 ， JAVA安装 环境搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey7jvj9.html">Spark SQL 1&period;3测试</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mnyxm8.html">Kettle参数化配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzrlkw8.html">【前端】jQuery移动端左滑删除</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zwdpg9.html">BIOS基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey7xok9.html">【mongodb系统学习之十】mongodb查询（二）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
